package net.mcreator.insectocraft.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.insectocraft.entity.MosquitoEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class MosquitoRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(MosquitoEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelmosquito(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("insectocraft:textures/texturemosquito.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.9.3
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelmosquito extends EntityModel<Entity> {
		private final ModelRenderer body;
		private final ModelRenderer wing1;
		private final ModelRenderer cube_r1;
		private final ModelRenderer wing2;
		private final ModelRenderer cube_r2;
		private final ModelRenderer nose;
		private final ModelRenderer cube_r3;
		private final ModelRenderer leg1;
		private final ModelRenderer leg2;
		private final ModelRenderer leg3;
		private final ModelRenderer leg4;
		public Modelmosquito() {
			textureWidth = 16;
			textureHeight = 16;
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 24.0F, 0.0F);
			body.setTextureOffset(0, 0).addBox(-1.0F, -7.0F, -3.0F, 1.0F, 1.0F, 5.0F, 0.0F, false);
			body.setTextureOffset(0, 6).addBox(0.0F, -7.0F, -3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			body.setTextureOffset(0, 2).addBox(-2.0F, -7.0F, -3.0F, 1.0F, 1.0F, 1.0F, 0.0F, false);
			wing1 = new ModelRenderer(this);
			wing1.setRotationPoint(0.0F, 24.0F, 0.0F);
			cube_r1 = new ModelRenderer(this);
			cube_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			wing1.addChild(cube_r1);
			setRotationAngle(cube_r1, 0.0F, 0.0F, -0.5672F);
			cube_r1.setTextureOffset(5, 0).addBox(3.0F, -6.0F, -1.0F, 3.0F, 0.0F, 2.0F, 0.0F, false);
			wing2 = new ModelRenderer(this);
			wing2.setRotationPoint(0.0F, 24.0F, 0.0F);
			cube_r2 = new ModelRenderer(this);
			cube_r2.setRotationPoint(0.0F, 0.0F, 0.0F);
			wing2.addChild(cube_r2);
			setRotationAngle(cube_r2, -0.0266F, -0.0346F, 0.6569F);
			cube_r2.setTextureOffset(5, 2).addBox(-7.0F, -5.0F, -1.0F, 2.0F, 0.0F, 2.0F, 0.0F, false);
			nose = new ModelRenderer(this);
			nose.setRotationPoint(0.0F, 24.0F, 0.0F);
			cube_r3 = new ModelRenderer(this);
			cube_r3.setRotationPoint(0.0F, 0.0F, 0.0F);
			nose.addChild(cube_r3);
			setRotationAngle(cube_r3, 0.6109F, 0.0F, 0.0F);
			cube_r3.setTextureOffset(0, 0).addBox(-1.0F, -7.0F, 0.0F, 1.0F, 0.0F, 2.0F, 0.0F, false);
			leg1 = new ModelRenderer(this);
			leg1.setRotationPoint(0.0F, 24.0F, 0.0F);
			leg1.setTextureOffset(2, 3).addBox(0.0F, -6.0F, 1.0F, 0.0F, 1.0F, 1.0F, 0.0F, false);
			leg2 = new ModelRenderer(this);
			leg2.setRotationPoint(0.0F, 24.0F, 0.0F);
			leg2.setTextureOffset(3, 1).addBox(0.0F, -6.0F, -1.0F, 0.0F, 1.0F, 1.0F, 0.0F, false);
			leg3 = new ModelRenderer(this);
			leg3.setRotationPoint(0.0F, 24.0F, 0.0F);
			leg3.setTextureOffset(0, 3).addBox(-1.0F, -6.0F, 1.0F, 0.0F, 1.0F, 1.0F, 0.0F, false);
			leg4 = new ModelRenderer(this);
			leg4.setRotationPoint(0.0F, 24.0F, 0.0F);
			leg4.setTextureOffset(0, 0).addBox(-1.0F, -6.0F, -1.0F, 0.0F, 1.0F, 1.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			wing1.render(matrixStack, buffer, packedLight, packedOverlay);
			wing2.render(matrixStack, buffer, packedLight, packedOverlay);
			nose.render(matrixStack, buffer, packedLight, packedOverlay);
			leg1.render(matrixStack, buffer, packedLight, packedOverlay);
			leg2.render(matrixStack, buffer, packedLight, packedOverlay);
			leg3.render(matrixStack, buffer, packedLight, packedOverlay);
			leg4.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.nose.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.nose.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.leg1.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.leg4.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.leg2.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.leg3.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.wing1.rotateAngleY = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.wing2.rotateAngleY = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.body.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.body.rotateAngleX = f4 / (180F / (float) Math.PI);
		}
	}
}
